(function(){


var plugin_active = false; 




dl_load_elements();

dl_define_resize_utilities();




function injectJs(link) {
   var scr = document.createElement('script');
   scr.type = "text/javascript";
   scr.src = link;
   scr.id = "dl_injected_script";
   
   if (document.getElementById('dl_injected_script') == null) {
      document.getElementsByTagName('head')[0].appendChild(scr);
   }

   window.postMessage({ 
      type: "get_displayed_page_data", 
   }, "/");

   //document.getElementsByTagName('head')[0].removeChild(scr)
}


//listen for messages from displayed page and send them to background
window.addEventListener("message", function(event) {

   if ( (event.source === window) && (typeof event.data.type !== "undefined") && (event.data.type === "from_displayed_page_data") ) {

      chrome.runtime.sendMessage({         
         "type": "from_content_data", 
         "tc_vars": event.data.tc_vars,
         "dataLayer": event.data.dataLayer,
         "url": event.data.url,
      });
   }

   if ( (event.origin === "https://webapi.shiny.it") && (typeof event.data.type !== "undefined") && (event.data.type === "from_iframe_click") ) {
   
      dl_tablink_clicked(dl_get_label_list(event.data.link_id)[0].id);
 
  }

}, false);



//listen for messages from background
chrome.runtime.onMessage.addListener(

   function(request, sender, sendResponse) {
      
      if ( (typeof request.type !== "undefined") && (request.type === "request_data_from_background") ) {
         if (plugin_active)
            injectJs(chrome.extension.getURL("inject.js"));
      }

      if ( (typeof request.type !== "undefined") && (request.type === "status_changed_data_from_background") ) {
         plugin_active = request.active;
         if (plugin_active) {
            dl_load_elements();
            injectJs(chrome.extension.getURL("inject.js"));
         }

         var tablinks = document.getElementsByClassName("dl_tablink");
         var content = document.getElementById("dl_tabcontent")
         var button = document.getElementById("dl_button_x");
         for (var i = 0; i < tablinks.length; i++) {
            if (plugin_active) {
               tablinks[i].className = tablinks[i].className.replace(" active", "");
               tablinks[i].style.setProperty("display", "inline-block", "important");
            } else {
               tablinks[i].style.setProperty("display", "none", "important");
               content.style.setProperty("display", "none", "important");
               button.style.setProperty("display", "none", "important");
            }
      
         }
      }

      //transmit messages from background (related to the current tab) to the iframe
      if ( (typeof request.type !== "undefined") && (request.type === "data_from_background_to_content") ) {

         dl_history_url_list_update(request.sessions_data.history, request.sessions_data.session_id);
         
         var iframe = document.getElementById("dl_iframe");
         request.sessions_data.type = "display_tc_vars";
         try {
            iframe.contentWindow.postMessage(request.sessions_data, "https://webapi.shiny.it");
         } catch (err) {}
      }

   }

);


setTimeout(function () {
   chrome.runtime.sendMessage({
      "type": "content_has_been_load"
   });
}, 100);



})();

