function dl_history_url_list_update(history, selected_id) {
   var history_text = document.getElementById("dl_history_text");
   var url_list = history.url_list;
   var id_list = history.id_list;
   var dl_details_list = history.dl_details_list;
   var i, str;
   var color_ga = dl_get_label_list('ga')[0].color;
   var color_tc = dl_get_label_list('tc')[0].color;
   var link_ga_id = dl_get_label_list('ga')[0].id;
   var link_tc_id = dl_get_label_list('tc')[0].id;



   if (typeof selected_id == "undefined" && id_list.length>0)
      selected_id = id_list[0];

   for (i=0; i<url_list.length && i<id_list.length; i++) {
      var el_id = "dl_url_link_" + i;
      var p_el = document.getElementById(el_id);
      
      var t_url_id = "dl_t_url_span" + i;
      var t_url = document.getElementById(t_url_id);

      var t_tc_id = "dl_t_tc_span" + i;
      var t_tc = document.getElementById(t_tc_id);

      var t_ga_id = "dl_t_ga_span" + i;
      var t_ga = document.getElementById(t_ga_id);

      if (!p_el || typeof p_el === "undefined") { 
         p_el = document.createElement("p");
         p_el.id = el_id;
         p_el.className = "dl_url_link";

         p_el.addEventListener('click', function(){

            chrome.runtime.sendMessage({
               "type": "history_url_has_been_clicked",
               "session_id": this.name
            });

         }, false);

         t_url = document.createElement("span");
         t_url.id = t_url_id;
         p_el.appendChild(t_url);

         p_el.appendChild(document.createElement("br"));

         t_ga = document.createElement("span");
         t_ga.id = t_ga_id;
         t_ga.style.color = color_ga;
         t_ga.addEventListener("click", function(){
            dl_tablink_clicked(link_ga_id);
         });
         p_el.appendChild(t_ga);

         t_tc = document.createElement("span");
         t_tc.id = t_tc_id;
         t_tc.style.color = color_tc;
         t_tc.addEventListener("click", function(){
            dl_tablink_clicked(link_tc_id);
         });
         p_el.appendChild(t_tc);
         
         history_text.appendChild(p_el);
      }

      p_el.title = url_list[i];
      p_el.name = id_list[i];


      if (p_el.name == selected_id)
         p_el.style.fontWeight = 'bold';
      else
         p_el.style.fontWeight = 'normal';


      if (!!url_list[i] && typeof url_list[i] !== "undefined"){
         t_url.textContent = url_list[i];

         t_tc.textContent = "";
         t_ga.textContent = "";
         if ( dl_details_list[i].hasOwnProperty("PV") )
            t_ga.textContent += " PV";
         if ( dl_details_list[i].hasOwnProperty("EV") )
            t_ga.textContent += " EV";
         if ( dl_details_list[i].hasOwnProperty("TC") )
            t_tc.textContent += " TC";

      }

   }

}

